﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace P15_1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        //Мировая матрица
        Matrix WorldMatrixM, WorldMatrixM1, WorldMatrixM2;
        //Направление движения для модели modelCls1
        Vector3 directM1;
        //Модели - 
        //modelCls вращается
        //modelCls1 перемещается по клавиатурным командам
        //modelCls2 изменяет размер
        modCls modelCls, modelCls1, modelCls2;
        //Переменные для текущего размера и 
        //текущего приращения размера модели modelCls2
        float size, sizeDelta;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            //загрузка моделей и создание объектов, используемых для 
            //хранения информации о моделях и их вывода на экран
            modelCls = new modCls(this, Content.Load<Model>("cube"), graphics);
            modelCls1 = new modCls(this, Content.Load<Model>("ball"), graphics);
            modelCls2 = new modCls(this, Content.Load<Model>("ball2"), graphics);
            //Добавляем объекты в коллекцию Components - для их 
            //автоматического вывода на экран
            Components.Add(modelCls);
            Components.Add(modelCls1);
            Components.Add(modelCls2);
            //Значения для приращения размера и текущего размера
            sizeDelta = 0.01f;
            size = 0.5f;
            //Установка исходного положения для модели modelCls1
            directM1 = new Vector3(2.0f, -1.0f, 1.0f);
            //Установка матриц, которые используются для управления объектами
            WorldMatrixM = Matrix.Identity;
            WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            WorldMatrixM2 = Matrix.CreateScale(size);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {


            KeyboardState kb = Keyboard.GetState();
            //По нажатии клавиши-стрелки "вверх" перемещаем модель
            //modelCls1 вверх
            if (kb.IsKeyDown(Keys.Up))
            {
                directM1.Y=directM1 .Y +0.1f;
                WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            }
            //Нажатие клавиши "вниз" - перемещение вниз
            if (kb.IsKeyDown(Keys.Down))
            {
                directM1.Y = directM1.Y - 0.1f;
                WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            }
            //Нажатие клавиши "влево" - перемещение влево
            if (kb.IsKeyDown(Keys.Left))
            {
                directM1.X = directM1.X - 0.1f;
                WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            }
            //Нажатие клавиши "вправо" - перемещение вправо
            if (kb.IsKeyDown(Keys.Right))
            {
                directM1.X = directM1.X + 0.1f;
                WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            }
            //Нажатие клавиши "W" - перемещение вперед
            if (kb.IsKeyDown(Keys.W))
            {
                directM1.Z = directM1.Z - 0.1f;
                WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            }
            //Нажатие клавиши "S" - перемещение назад
            if (kb.IsKeyDown(Keys.S))
            {
                directM1.Z = directM1.Z + 0.1f;
                WorldMatrixM1 = Matrix.CreateTranslation(directM1);
            }
            
            //Если текущий размер меньше 0.5 - 
            //устанавливаем приращение, равное 0.01
            //Если текущий размер больше 1.5 -
            //устанавливаем приращение -0.01
            if (size < 0.5) sizeDelta = 0.01f;
            if (size > 1.5) sizeDelta = -0.01f;
            size += sizeDelta;

            //Матрица для объекта modelCls1 устанавливается для поворота его вокруг
            //осей X и Y на один градус
            WorldMatrixM = WorldMatrixM * Matrix.CreateRotationY(MathHelper.ToRadians(1))*
                Matrix .CreateRotationX (MathHelper .ToRadians (1));
            //Установка матрицы для объекта modelCls2
            WorldMatrixM2 = Matrix.CreateScale(size) * Matrix.CreateTranslation(new Vector3(-5.0f, 2.0f, -3.0f));
            //Передаем матрицы объектам
            modelCls.WorldMatrix = WorldMatrixM;
            modelCls1.WorldMatrix = WorldMatrixM1;
            modelCls2.WorldMatrix = WorldMatrixM2;
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
     
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
            

            base.Draw(gameTime);
        }
    }
}
